--[[
	History script for HeXHub running the Hex Script plugin.
	http://sourceforge.net/projects/hexhub
	
	History script (C) Copyright 2008 Morten Laren
]]

Hex.SetAboutString("Morten Larsen, 2008")

-- max number of lines to keep
top = 25

-- table for chat lines
t = {}

-- the !history trigger
trig = Hex.Trigger()
trig:SetTrigger("history")

-- a string shown in !help
hlp = Hex.HelpString(0, "EN")
hlp:SetString("!history\t\t\t-\tview the last "..top.." lines of chat.")

-- a user menu shown in the hub menu
usrcmd = Hex.UserCommand()
usrcmd:SetUserCommandString("$UserCommand 1 1 Chat history$<%[mynick]> !history&#124;|")

function OnTrigger(iTriggerId, iUserId, bIsPm, sParameters)
	if trig:GetTriggerId() == iTriggerId then
		local bot = Hex.User(0)
		local usr = Hex.User(iUserId)
		local head = nil
		local body = nil
		if (bIsPm == true) then
			head = "$To: "..usr:GetClientNick().." From: "..bot:GetNick().." $<"..bot:GetNick().."> "
		else
			head = "<"..bot:GetNick().."> "
		end
		
		if #t == 0 then 
			body = "The chat history is empty, try again later."
		else
			body = "Last "..(#t).." lines of mainchat:\n"..table.concat(t, "\n")
		end
		usr:SendData(head..body.."|")
	end
end

function OnPublicMessage(iUserId, sData)
	local _, _, s = sData:find("%b<> (.*)")

	if s == nil then return true end

	if string.find(s, "^[^ ]+ is kicking [^ ]+ because:") == nil then 
		if #t >= top then table.remove(t, 1) end
		table.insert(t, os.date("[%H:%M:%S] ")..sData)
	end
	
	return true
end
